import dune.codegen.blockstructured.quadrature
import dune.codegen.blockstructured.argument
import dune.codegen.blockstructured.geometry
import dune.codegen.blockstructured.spaces
import dune.codegen.blockstructured.basis
import dune.codegen.blockstructured.transformations
from dune.codegen.options import get_form_option
from dune.codegen.blockstructured.spaces import lfs_inames
from dune.codegen.blockstructured.basis import (pymbolic_reference_gradient,
                                                pymbolic_basis)
from dune.codegen.blockstructured.geometry import (pymbolic_jacobian_inverse,
                                                   pymbolic_jacobian_determinant,
                                                   pymbolic_facet_jacobian_determinant,
                                                   to_global)
from dune.codegen.blockstructured.tools import sub_element_inames
from dune.codegen.pdelab import PDELabInterface


class BlockStructuredInterface(PDELabInterface):
    def __init__(self):
        PDELabInterface.__init__(self)

    def generate_accumulation_instruction(self, expr, visitor):
        if get_form_option('vectorization_blockstructured'):
            from dune.codegen.blockstructured.accumulation import generate_accumulation_instruction
            return generate_accumulation_instruction(expr, visitor)
        else:
            return PDELabInterface.generate_accumulation_instruction(self, expr, visitor)
